diff -crN nakedmudv1.5/src/inform.c nakedmudv2.0/src/inform.c
*** nakedmudv1.5/src/inform.c	2010-11-01 15:54:17.000000000 -0500
--- nakedmudv2.0/src/inform.c	2010-11-01 15:54:18.000000000 -0500
***************
*** 18,35 ****
  #include "utils.h"
  #include "body.h"
  #include "races.h"
- #include "items.h"
  #include "handler.h"
  #include "socket.h"
  #include "inform.h"
  #include "log.h"
  
  // optional module headers
  #ifdef MODULE_TIME
  #include "time/mudtime.h"
  #endif
  
  
  //*****************************************************************************
  //
  // local functions
--- 18,49 ----
  #include "utils.h"
  #include "body.h"
  #include "races.h"
  #include "handler.h"
  #include "socket.h"
  #include "inform.h"
  #include "log.h"
  
+ 
+ 
+ //*****************************************************************************
+ // mandatory modules
+ //*****************************************************************************
+ #include "items/items.h"
+ #include "items/portal.h"
+ #include "items/container.h"
+ #include "items/furniture.h"
+ 
+ 
+ 
+ //*****************************************************************************
  // optional module headers
+ //*****************************************************************************
  #ifdef MODULE_TIME
  #include "time/mudtime.h"
  #endif
  
  
+ 
  //*****************************************************************************
  //
  // local functions
***************
*** 46,52 ****
    char *chars = print_list(can_see, charGetName, charGetMultiName);
    if(*chars) send_to_char(ch, "%s %s %s %s%s.\r\n",
  			  chars, (listSize(can_see) == 1 ? "is" : "are"),
! 			  (objGetSubtype(furniture) == FURNITURE_AT ?"at":"on"),
  			  objGetName(furniture),
  			  (charGetFurniture(ch) == furniture ?" with you": ""));
    // everyone was invisible to us... we should still show the furniture though
--- 60,66 ----
    char *chars = print_list(can_see, charGetName, charGetMultiName);
    if(*chars) send_to_char(ch, "%s %s %s %s%s.\r\n",
  			  chars, (listSize(can_see) == 1 ? "is" : "are"),
! 			  (furnitureGetType(furniture)==FURNITURE_AT?"at":"on"),
  			  objGetName(furniture),
  			  (charGetFurniture(ch) == furniture ?" with you": ""));
    // everyone was invisible to us... we should still show the furniture though
***************
*** 136,142 ****
    free(new_desc);
  
    // list container-related stuff
!   if(objGetType(obj) == ITEM_CONTAINER) {
      send_to_char(ch, "{g%s is %s%s.\r\n",
  		 objGetName(obj), 
  		 (containerIsClosed(obj) ? "closed" : "opened"),
--- 150,156 ----
    free(new_desc);
  
    // list container-related stuff
!   if(objIsType(obj, "container")) {
      send_to_char(ch, "{g%s is %s%s.\r\n",
  		 objGetName(obj), 
  		 (containerIsClosed(obj) ? "closed" : "opened"),
***************
*** 156,162 ****
    }
  
    // list furniture-related stuff
!   else if(objGetType(obj) == ITEM_FURNITURE) {
      int num_sitters = listSize(objGetUsers(obj));
  
      send_to_char(ch, "\r\n");
--- 170,176 ----
    }
  
    // list furniture-related stuff
!   else if(objIsType(obj, "furniture")) {
      int num_sitters = listSize(objGetUsers(obj));
  
      send_to_char(ch, "\r\n");
***************
*** 169,175 ****
        char *chars = print_list(can_see, charGetName, charGetMultiName);
        if(*chars) send_to_char(ch, "{g%s %s %s %s%s.\r\n",
  			      chars, (listSize(can_see) == 1 ? "is" : "are"),
! 			      (objGetSubtype(obj) == FURNITURE_AT ? "at":"on"),
  			      objGetName(obj),
  			      (charGetFurniture(ch) == obj ? " with you" : ""));
        deleteList(can_see);
--- 183,189 ----
        char *chars = print_list(can_see, charGetName, charGetMultiName);
        if(*chars) send_to_char(ch, "{g%s %s %s %s%s.\r\n",
  			      chars, (listSize(can_see) == 1 ? "is" : "are"),
! 			      (furnitureGetType(obj)==FURNITURE_AT ? "at":"on"),
  			      objGetName(obj),
  			      (charGetFurniture(ch) == obj ? " with you" : ""));
        deleteList(can_see);
***************
*** 353,362 ****
  
  
  void text_to_char(CHAR_DATA *ch, const char *txt) {
!   if (txt && *txt && charGetSocket(ch) && 
!       socketGetState(charGetSocket(ch)) == STATE_PLAYING) {
      text_to_buffer(charGetSocket(ch), txt);
!     charGetSocket(ch)->bust_prompt = TRUE;
    }
  
    // if it's a PC or we are not in game, then
--- 367,377 ----
  
  
  void text_to_char(CHAR_DATA *ch, const char *txt) {
!   //  if (txt && *txt && charGetSocket(ch) && 
!   //      socketGetState(charGetSocket(ch)) == STATE_PLAYING) {
!   if(txt && *txt && charGetSocket(ch)) {
      text_to_buffer(charGetSocket(ch), txt);
!     socketBustPrompt(charGetSocket(ch));
    }
  
    // if it's a PC or we are not in game, then
***************
*** 495,512 ****
      // is it an extra description?
      else if(found_type == FOUND_EDESC) {
        // get the set it belongs to
!       EDESC_SET *set = getEdescSet(found);
        // if it belongs to a set, highlight keywords
        if(set) {
  	char *new_edesc = tagEdescs(set,
! 				    getEdescDescription(found),
  				    "{c", "{g");
  	send_to_char(ch, "{g%s", new_edesc);
  	free(new_edesc);
        }
        // otherwise, just show the plain desc
        else
! 	send_to_char(ch, "{g%s", getEdescDescription(found));
      }
  
      // is it an item?
--- 510,527 ----
      // is it an extra description?
      else if(found_type == FOUND_EDESC) {
        // get the set it belongs to
!       EDESC_SET *set = edescGetSet(found);
        // if it belongs to a set, highlight keywords
        if(set) {
  	char *new_edesc = tagEdescs(set,
! 				    edescSetGetDesc(found),
  				    "{c", "{g");
  	send_to_char(ch, "{g%s", new_edesc);
  	free(new_edesc);
        }
        // otherwise, just show the plain desc
        else
! 	send_to_char(ch, "{g%s", edescSetGetDesc(found));
      }
  
      // is it an item?
***************
*** 516,533 ****
      // is it something inside of an object?
      else if(found_type == FOUND_IN_OBJ) {
        // show the destination we're peering at
!       if(objGetType(found) == ITEM_PORTAL) {
! 	ROOM_DATA *dest = worldGetRoom(gameworld, objGetVal(found, 0));
  	if(dest) {
! 	  send_to_char(ch, "You peer inside the portal.\r\n");
  	  look_at_room(ch, dest);
  	}
  	else
  	  send_to_char(ch, 
! 		       "The portal is murky, and you cannot "
! 		       "make out anything on the other side.\r\n");
        }
!       else if(objGetType(found) != ITEM_CONTAINER)
  	send_to_char(ch, "%s is not a container or portal.\r\n",
  		     objGetName(found));
        else if(containerIsClosed(found))
--- 531,549 ----
      // is it something inside of an object?
      else if(found_type == FOUND_IN_OBJ) {
        // show the destination we're peering at
!       if(objIsType(found, "portal")) {
! 	ROOM_DATA *dest = worldGetRoom(gameworld, portalGetDest(found));
  	if(dest) {
! 	  send_to_char(ch, "You peer inside %s.\r\n", see_obj_as(ch, found));
  	  look_at_room(ch, dest);
  	}
  	else
  	  send_to_char(ch, 
! 		       "%s is murky, and you cannot "
! 		       "make out anything on the other side.\r\n",
! 		       see_obj_as(ch, found));
        }
!       else if(!objIsType(found, "container"))
  	send_to_char(ch, "%s is not a container or portal.\r\n",
  		     objGetName(found));
        else if(containerIsClosed(found))
***************
*** 597,603 ****
  {
    CHAR_DATA *plr;
    SOCKET_DATA *dsock;
!   BUFFER *buf = buffer_new(MAX_BUFFER);
    LIST_ITERATOR *sock_i = newListIterator(socket_list);
    int socket_count = 0, playing_count = 0;
  
--- 613,619 ----
  {
    CHAR_DATA *plr;
    SOCKET_DATA *dsock;
!   BUFFER *buf = newBuffer(MAX_BUFFER);
    LIST_ITERATOR *sock_i = newListIterator(socket_list);
    int socket_count = 0, playing_count = 0;
  
***************
*** 608,629 ****
  
    ITERATE_LIST(dsock, sock_i) {
      socket_count++;
!     if (dsock->state != STATE_PLAYING) continue;
!     if ((plr = dsock->player) == NULL) continue;
      playing_count++;
      bprintf(buf, "{y%-8s %-3s  {g)  {c%-12s {b%26s\r\n", 
  	    (charGetLevel(plr) == LEVEL_PLAYER ? "player" :
  	     (charGetLevel(plr) == LEVEL_BUILDER  ? "builder" :
  	      (charGetLevel(plr) == LEVEL_SCRIPTER    ? "scripter" : "admin"))),
  	    raceGetAbbrev(charGetRace(plr)),
! 	    charGetName(plr), dsock->hostname);
    }
  
    bprintf(buf, "\r\n{g%d character%s connected. %d playing.\r\n",
  	  socket_count, (socket_count == 1 ? "" : "s"), playing_count);
!   page_string(charGetSocket(ch), buf->data);
    //  send_to_char(ch, buf->data);
!   buffer_free(buf);
    deleteListIterator(sock_i);
  }
  
--- 624,645 ----
  
    ITERATE_LIST(dsock, sock_i) {
      socket_count++;
!     //    if (dsock->state != STATE_PLAYING) continue;
!     if ((plr = socketGetChar(dsock)) == NULL) continue;
      playing_count++;
      bprintf(buf, "{y%-8s %-3s  {g)  {c%-12s {b%26s\r\n", 
  	    (charGetLevel(plr) == LEVEL_PLAYER ? "player" :
  	     (charGetLevel(plr) == LEVEL_BUILDER  ? "builder" :
  	      (charGetLevel(plr) == LEVEL_SCRIPTER    ? "scripter" : "admin"))),
  	    raceGetAbbrev(charGetRace(plr)),
! 	    charGetName(plr), socketGetHostname(dsock));
    }
  
    bprintf(buf, "\r\n{g%d character%s connected. %d playing.\r\n",
  	  socket_count, (socket_count == 1 ? "" : "s"), playing_count);
!   page_string(charGetSocket(ch), bufferString(buf));
    //  send_to_char(ch, buf->data);
!   deleteBuffer(buf);
    deleteListIterator(sock_i);
  }
  
***************
*** 738,745 ****
        case '$':
  	buf[j] = '$';
  	j++;
        default:
! 	// do nothing ...
  	break;
        }
      }
--- 754,762 ----
        case '$':
  	buf[j] = '$';
  	j++;
+ 	break;
        default:
! 	// do nothing
  	break;
        }
      }
diff -crN nakedmudv1.5/src/inform.d nakedmudv2.0/src/inform.d
*** nakedmudv1.5/src/inform.d	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv2.0/src/inform.d	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,5 ----
+ inform.d inform.o: inform.c mud.h wrapsock.h property_table.h list.h map.h \
+   hashtable.h set.h buffer.h bitvector.h character.h object.h world.h \
+   room.h exit.h extra_descs.h utils.h body.h races.h handler.h socket.h \
+   inform.h log.h items/items.h items/portal.h items/container.h \
+   items/furniture.h time/mudtime.h
diff -crN nakedmudv1.5/src/interpret.c nakedmudv2.0/src/interpret.c
*** nakedmudv1.5/src/interpret.c	2010-11-01 15:54:17.000000000 -0500
--- nakedmudv2.0/src/interpret.c	2010-11-01 15:54:18.000000000 -0500
***************
*** 14,26 ****
  #include "commands.h"
  #include "action.h"
  
  // optional modules
  #ifdef MODULE_FACULTY
  #include "faculty/faculty.h"
  #endif
- #ifdef MODULE_SCRIPTS
- #include "scripts/script.h"
- #endif
  #ifdef MODULE_ALIAS
  #include "alias/alias.h"
  #endif
--- 14,34 ----
  #include "commands.h"
  #include "action.h"
  
+ 
+ 
+ //*****************************************************************************
+ // mandatory modules
+ //*****************************************************************************
+ #include "scripts/script.h"
+ 
+ 
+ 
+ //*****************************************************************************
  // optional modules
+ //*****************************************************************************
  #ifdef MODULE_FACULTY
  #include "faculty/faculty.h"
  #endif
  #ifdef MODULE_ALIAS
  #include "alias/alias.h"
  #endif
***************
*** 87,99 ****
  	  LEVEL_PLAYER, TRUE, TRUE );
    add_cmd("ask",        NULL, cmd_ask,      0, POS_SITTING,  POS_FLYING,
  	  LEVEL_PLAYER, TRUE, FALSE);
  
    // B
    add_cmd("back",       NULL, cmd_back,     0, POS_UNCONCIOUS, POS_FLYING,
  	  LEVEL_PLAYER, TRUE, FALSE);
    add_cmd("buildwalk",  NULL, cmd_tog_prf,  PRF_BUILDWALK, 
  	  POS_UNCONCIOUS, POS_FLYING, LEVEL_BUILDER, FALSE, FALSE);
! 
  
    // C
    add_cmd("chat",       NULL, cmd_chat,     0, POS_UNCONCIOUS, POS_FLYING,
--- 95,112 ----
  	  LEVEL_PLAYER, TRUE, TRUE );
    add_cmd("ask",        NULL, cmd_ask,      0, POS_SITTING,  POS_FLYING,
  	  LEVEL_PLAYER, TRUE, FALSE);
+   add_cmd("at",         NULL, cmd_at,       0, POS_UNCONCIOUS, POS_FLYING,
+ 	  LEVEL_BUILDER, TRUE, FALSE);
  
    // B
    add_cmd("back",       NULL, cmd_back,     0, POS_UNCONCIOUS, POS_FLYING,
  	  LEVEL_PLAYER, TRUE, FALSE);
+   add_cmd("buildwalk",  NULL, cmd_buildwalk, 0, POS_UNCONCIOUS, POS_FLYING,
+ 	  LEVEL_BUILDER, FALSE, FALSE);
+   /*
    add_cmd("buildwalk",  NULL, cmd_tog_prf,  PRF_BUILDWALK, 
  	  POS_UNCONCIOUS, POS_FLYING, LEVEL_BUILDER, FALSE, FALSE);
!   */
  
    // C
    add_cmd("chat",       NULL, cmd_chat,     0, POS_UNCONCIOUS, POS_FLYING,
***************
*** 120,127 ****
  	  LEVEL_PLAYER, TRUE, TRUE );
  
    // E
-   add_cmd("enter",      NULL, cmd_enter,    0, POS_STANDING, POS_FLYING,
- 	  LEVEL_PLAYER, TRUE, TRUE );
    add_cmd("emote",      NULL, cmd_emote,    0, POS_SITTING,  POS_FLYING,
  	  LEVEL_PLAYER, TRUE, FALSE);
    add_cmd(":",          NULL, cmd_emote,    0, POS_SITTING,  POS_FLYING,
--- 133,138 ----
***************
*** 149,158 ****
    add_cmd("goto",       NULL, cmd_goto,     0, POS_STANDING, POS_FLYING,
  	  LEVEL_BUILDER, FALSE, TRUE );
  
-   // H
-   //  add_cmd("help",       NULL, cmd_help,     0, POS_UNCONCIOUS, POS_FLYING,
-   //	  LEVEL_PLAYER, TRUE, FALSE);
- 
    // I
    add_cmd("inventory",  NULL, cmd_inventory,0, POS_SITTING,  POS_FLYING,
  	  LEVEL_PLAYER, TRUE, FALSE);
--- 160,165 ----
***************
*** 172,179 ****
  	  LEVEL_ADMIN, FALSE, FALSE);
  
    // M
-   add_cmd("mapwalk",    NULL, cmd_tog_prf,  PRF_MAPWALK,
- 	  POS_UNCONCIOUS, POS_FLYING, LEVEL_PLAYER, FALSE, FALSE);
    add_cmd("mlist",      NULL, cmd_mlist,    0, POS_UNCONCIOUS, POS_FLYING,
  	  LEVEL_BUILDER, FALSE, FALSE);
    add_cmd("more",       NULL, cmd_more,     0, POS_UNCONCIOUS, POS_FLYING,
--- 179,184 ----
***************
*** 186,193 ****
  	  LEVEL_PLAYER, TRUE, TRUE );
  
    // P
!   add_cmd("put",        NULL, cmd_put,      0, POS_SITTING,  POS_FLYING,
  	  LEVEL_PLAYER, TRUE,  TRUE );
    add_cmd("purge",      NULL, cmd_purge,    0, POS_SITTING,  POS_FLYING,
  	  LEVEL_BUILDER, FALSE, FALSE);
    
--- 191,200 ----
  	  LEVEL_PLAYER, TRUE, TRUE );
  
    // P
!   add_cmd("put",        "p", cmd_put,       0, POS_SITTING,  POS_FLYING,
  	  LEVEL_PLAYER, TRUE,  TRUE );
+   add_cmd("page",       NULL, cmd_page,     0, POS_SITTING,  POS_FLYING,
+ 	  LEVEL_BUILDER, TRUE, FALSE);
    add_cmd("purge",      NULL, cmd_purge,    0, POS_SITTING,  POS_FLYING,
  	  LEVEL_BUILDER, FALSE, FALSE);
    
***************
*** 200,205 ****
--- 207,214 ----
  	  LEVEL_PLAYER, TRUE, TRUE );
    add_cmd("rlist",      NULL, cmd_rlist,    0, POS_UNCONCIOUS, POS_FLYING,
  	  LEVEL_BUILDER, FALSE, FALSE);
+   add_cmd("repeat",     NULL, cmd_repeat,   0, POS_UNCONCIOUS, POS_FLYING,
+ 	  LEVEL_ADMIN, FALSE, FALSE);
  
    // S
    add_cmd("say",        NULL, cmd_say,      0, POS_SITTING,  POS_FLYING,
***************
*** 218,230 ****
  	  LEVEL_PLAYER, TRUE, TRUE );
    add_cmd("stop",       NULL, cmd_stop,     0, POS_SITTING, POS_FLYING,
  	  LEVEL_PLAYER, TRUE, FALSE);
- #ifdef MODULE_SCRIPTS
    // really, we -should- put this in the scripts module, but there are some
    // very nice functions in builder.c that cmd_sclist uses to print scripts,
    // which wouldn't be accessable from outside of builder.c
    add_cmd("sclist",     NULL, cmd_sclist,   0, POS_UNCONCIOUS, POS_FLYING,
  	  LEVEL_BUILDER, FALSE, FALSE);
- #endif
  
    // T
    add_cmd("take",       NULL, cmd_get,      0, POS_SITTING,  POS_FLYING,
--- 227,237 ----
***************
*** 253,260 ****
  	  LEVEL_BUILDER, FALSE, FALSE);
    add_cmd("worn",       NULL, cmd_equipment,0, POS_SITTING,  POS_FLYING,
  	  LEVEL_PLAYER, TRUE, FALSE);
-   add_cmd("write",      NULL, cmd_write,    0, POS_SITTING, POS_FLYING,
- 	  LEVEL_PLAYER, TRUE, TRUE);
  
    // Z
    add_cmd("zlist",      NULL, cmd_zlist,    0, POS_SITTING,  POS_FLYING,
--- 260,265 ----
***************
*** 299,304 ****
--- 304,316 ----
  }
  
  //
+ // return TRUE if the command already exists.
+ //
+ bool cmd_exists(const char *cmd) {
+   return (find_cmd(cmd, FALSE) != NULL);
+ }
+ 
+ //
  // remove (and delete) a command
  //
  void remove_cmd(const char *cmd) {
***************
*** 335,341 ****
  
  // show the character all of the commands he or she can perform
  void show_commands(CHAR_DATA *ch, int min_lev, int max_lev) {
!   BUFFER *buf = buffer_new(MAX_BUFFER);
    int i, col = 0;
  
    // go over all of our buckets
--- 347,353 ----
  
  // show the character all of the commands he or she can perform
  void show_commands(CHAR_DATA *ch, int min_lev, int max_lev) {
!   BUFFER *buf = newBuffer(MAX_BUFFER);
    int i, col = 0;
  
    // go over all of our buckets
***************
*** 348,361 ****
  	continue;
        bprintf(buf, "%-20.20s", cmd->cmd_name);
        if (!(++col % 4))
! 	bprintf(buf, "\r\n");      
      }
      deleteListIterator(buck_i);
    }
  
    if (col % 4) bprintf(buf, "\r\n");
!   text_to_char(ch, buf->data);
!   buffer_free(buf);
  }
  
  
--- 360,373 ----
  	continue;
        bprintf(buf, "%-20.20s", cmd->cmd_name);
        if (!(++col % 4))
! 	bufferCat(buf, "\r\n");
      }
      deleteListIterator(buck_i);
    }
  
    if (col % 4) bprintf(buf, "\r\n");
!   text_to_char(ch, bufferString(buf));
!   deleteBuffer(buf);
  }
  
  
***************
*** 433,439 ****
  
  void handle_cmd_input(SOCKET_DATA *dsock, char *arg) {
    CHAR_DATA *ch;
!   if ((ch = dsock->player) == NULL)
      return;
    do_cmd(ch, arg, TRUE, TRUE);
  }
--- 445,451 ----
  
  void handle_cmd_input(SOCKET_DATA *dsock, char *arg) {
    CHAR_DATA *ch;
!   if ((ch = socketGetChar(dsock)) == NULL)
      return;
    do_cmd(ch, arg, TRUE, TRUE);
  }
***************
*** 480,489 ****
  
    // if we've got a command script, and we're not supposed
    // to follow through with our normal command, return out
- #ifdef MODULE_SCRIPTS
    if(scripts_ok && try_command_script(ch, command, arg))
      return;
- #endif
  
  
    // iterate over the commands that would be in our 
--- 492,499 ----
diff -crN nakedmudv1.5/src/interpret.d nakedmudv2.0/src/interpret.d
*** nakedmudv1.5/src/interpret.d	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv2.0/src/interpret.d	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,3 ----
+ interpret.d interpret.o: interpret.c mud.h wrapsock.h property_table.h list.h map.h \
+   hashtable.h set.h buffer.h bitvector.h utils.h character.h socket.h \
+   room.h movement.h commands.h action.h scripts/script.h alias/alias.h
diff -crN nakedmudv1.5/src/io.d nakedmudv2.0/src/io.d
*** nakedmudv1.5/src/io.d	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv2.0/src/io.d	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,2 ----
+ io.d io.o: io.c mud.h wrapsock.h property_table.h list.h map.h hashtable.h \
+   set.h buffer.h bitvector.h utils.h
diff -crN nakedmudv1.5/src/items/container.c nakedmudv2.0/src/items/container.c
*** nakedmudv1.5/src/items/container.c	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv2.0/src/items/container.c	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,238 ----
+ //*****************************************************************************
+ //
+ // container.c
+ //
+ // handles all of the functioning of the container item type. Stores data about 
+ // the contents and capacity of a container, and all the functions for 
+ // interacting with container types.
+ //
+ //*****************************************************************************
+ 
+ #include "../mud.h"
+ #include "../storage.h"
+ #include "../object.h"
+ #include "../world.h"
+ #include "../socket.h"
+ #include "../olc2/olc.h"
+ 
+ #include "items.h"
+ #include "iedit.h"
+ 
+ 
+ 
+ //*****************************************************************************
+ // item data for containers
+ //*****************************************************************************
+ typedef struct container_data {
+   double capacity;
+   int    key;
+   int    pick_diff;
+   bool   closable;
+   bool   closed;
+   bool   locked;
+ } CONTAINER_DATA;
+ 
+ CONTAINER_DATA *newContainerData() {
+   CONTAINER_DATA *data = malloc(sizeof(CONTAINER_DATA));
+   data->capacity  = 0;
+   data->key       = NOTHING;
+   data->pick_diff = 0;
+   data->closed    = FALSE;
+   data->locked    = FALSE;
+   return data;
+ }
+ 
+ void deleteContainerData(CONTAINER_DATA *data) {
+   free(data);
+ }
+ 
+ void containerDataCopyTo(CONTAINER_DATA *from, CONTAINER_DATA *to) {
+   *to = *from;
+ }
+ 
+ CONTAINER_DATA *containerDataCopy(CONTAINER_DATA *data) {
+   CONTAINER_DATA *new_data = newContainerData();
+   containerDataCopyTo(data, new_data);
+   return new_data;
+ }
+ 
+ STORAGE_SET *containerDataStore(CONTAINER_DATA *data) {
+   STORAGE_SET *set = new_storage_set();
+   store_double(set, "capacity", data->capacity);
+   store_int   (set, "key",      data->key);
+   store_int   (set, "pick_diff",data->pick_diff);
+   store_int   (set, "closable", data->closable);
+   store_int   (set, "closed",   data->closed);
+   store_int   (set, "locked",   data->locked);
+   return set;
+ }
+ 
+ CONTAINER_DATA *containerDataRead(STORAGE_SET *set) {
+   CONTAINER_DATA *data = newContainerData();
+   data->capacity = read_double(set, "capacity");
+   data->key      = read_int   (set, "key");
+   data->pick_diff= read_int   (set, "pick_diff");
+   data->closable = read_int   (set, "closable");
+   data->closed   = read_int   (set, "closed");
+   data->locked   = read_int   (set, "locked");
+   return data;
+ }
+ 
+ 
+ 
+ //*****************************************************************************
+ // functions for interacting with containers
+ //*****************************************************************************
+ double containerGetCapacity(OBJ_DATA *obj) {
+   CONTAINER_DATA *data = objGetTypeData(obj, "container");
+   return data->capacity;
+ }
+ 
+ void containerSetCapacity(OBJ_DATA *obj, double capacity) {
+   CONTAINER_DATA *data = objGetTypeData(obj, "container");
+   data->capacity = capacity;
+ }
+ 
+ bool containerIsClosable (OBJ_DATA *obj) {
+   CONTAINER_DATA *data = objGetTypeData(obj, "container");
+   return data->closable;
+ }
+ 
+ bool containerIsClosed   (OBJ_DATA *obj) {
+   CONTAINER_DATA *data = objGetTypeData(obj, "container");
+   return data->closed;
+ }
+ 
+ bool containerIsLocked   (OBJ_DATA *obj) {
+   CONTAINER_DATA *data = objGetTypeData(obj, "container");
+   return data->locked;
+ }
+ 
+ int  containerGetKey     (OBJ_DATA *obj) {
+   CONTAINER_DATA *data = objGetTypeData(obj, "container");
+   return data->key;
+ }
+ 
+ int  containerGetPicKDiff(OBJ_DATA *obj) {
+   CONTAINER_DATA *data = objGetTypeData(obj, "container");
+   return data->pick_diff;
+ }
+ 
+ void containerSetClosed  (OBJ_DATA *obj, bool closed) {
+   CONTAINER_DATA *data = objGetTypeData(obj, "container");
+   data->closed = closed;
+ }
+ 
+ void   containerSetClosable(OBJ_DATA *obj, bool closable) {
+   CONTAINER_DATA *data = objGetTypeData(obj, "container");
+   data->closable = closable;
+ }
+ 
+ void containerSetLocked  (OBJ_DATA *obj, bool locked) {
+   CONTAINER_DATA *data = objGetTypeData(obj, "container");
+   data->locked = locked;
+ }
+ 
+ void containerSetKey     (OBJ_DATA *obj, int  vnum) {
+   CONTAINER_DATA *data = objGetTypeData(obj, "container");
+   data->key = vnum;
+ }
+ 
+ void containerSetPickDiff(OBJ_DATA *obj, int  diff) {
+   CONTAINER_DATA *data = objGetTypeData(obj, "container");
+   data->pick_diff = diff;
+ }
+ 
+ 
+ 
+ //*****************************************************************************
+ // container olc
+ //*****************************************************************************
+ #define IEDIT_CONTAINER_CAPACITY      1
+ #define IEDIT_CONTAINER_KEY           2
+ #define IEDIT_CONTAINER_PICK_DIFF     3
+ 
+ // the resedit olc needs these declared
+ void iedit_container_menu   (SOCKET_DATA *sock, CONTAINER_DATA *data) {
+   send_to_socket(sock, 
+ 		 "{g1) Capacity : {c%1.2lf\r\n"
+ 		 "{g2) Key      : {c%d (%s)\r\n"
+ 		 "{g3) Closable : {c%s\r\n"
+ 		 "{g4) Pick diff: {c%d\r\n",
+ 		 data->capacity,
+ 		 data->key, 
+ 		 (worldGetObj(gameworld, data->key) ? 
+ 		  objGetName(worldGetObj(gameworld, data->key)) : "nothing"),
+ 		 (data->closable ? "yes" : "no"),
+ 		 data->pick_diff);
+ }
+ 
+ int  iedit_container_chooser(SOCKET_DATA *sock, CONTAINER_DATA *data, char option) {
+   switch(toupper(option)) {
+   case '1':
+     text_to_buffer(sock, "Enter a new weight capacity for the container: ");
+     return IEDIT_CONTAINER_CAPACITY;
+   case '2':
+     text_to_buffer(sock, "Enter akey vnum for the container (-1 for none): ");
+     return IEDIT_CONTAINER_KEY;
+   case '3':
+     data->closable = (data->closable + 1) % 2;
+     return MENU_NOCHOICE;
+   case '4':
+     text_to_buffer(sock, "How difficult is the lock to pick: ");
+     return IEDIT_CONTAINER_PICK_DIFF;
+   default: return MENU_CHOICE_INVALID;
+   }
+ }
+ 
+ bool iedit_container_parser (SOCKET_DATA *sock, CONTAINER_DATA *data, int choice, 
+ 			  const char *arg) {
+   switch(choice) {
+   case IEDIT_CONTAINER_CAPACITY: {
+     double capacity = atof(arg);
+     if(capacity <= 0)
+       return FALSE;
+     data->capacity = capacity;
+     return TRUE;
+   }
+   case IEDIT_CONTAINER_KEY: {
+     int key = atoi(arg);
+     // ugh... ugly logic. Clean this up one day?
+     //   Make sure what we're getting is a positive number or make sure it is
+     //   the NOTHING number (-1). Also make sure that, if it's not NOTHING, it
+     //   corresponds to a vnum of an object already created.
+     if((key != NOTHING && !worldGetObj(gameworld, key)) ||
+        (key != NOTHING && !isdigit(*arg)))
+       return FALSE;
+     data->key = key;
+     return TRUE;
+   }
+   case IEDIT_CONTAINER_PICK_DIFF: {
+     int diff = atoi(arg);
+     if(diff < 0 || !isdigit(*arg))
+       return FALSE;
+     data->pick_diff = diff;
+     return TRUE;
+   }
+   default: return FALSE;
+   }
+ }
+ 
+ 
+ 
+ //*****************************************************************************
+ // install the container item type
+ //*****************************************************************************
+ 
+ //
+ // this will need to be called by init_items() in items/items.c
+ void init_container(void) {
+   item_add_type("container", 
+   		newContainerData, deleteContainerData,
+   		containerDataCopyTo, containerDataCopy, 
+   		containerDataStore, containerDataRead);
+ 
+   // set up the container OLC too
+   item_add_olc("container", iedit_container_menu, iedit_container_chooser, 
+   	       iedit_container_parser);
+ }
diff -crN nakedmudv1.5/src/items/container.d nakedmudv2.0/src/items/container.d
*** nakedmudv1.5/src/items/container.d	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv2.0/src/items/container.d	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,3 ----
+ items/container.d items/container.o: items/container.c mud.h wrapsock.h property_table.h list.h \
+   map.h hashtable.h set.h buffer.h bitvector.h storage.h object.h world.h \
+   socket.h olc2/olc.h items/items.h items/iedit.h
diff -crN nakedmudv1.5/src/items/container.h nakedmudv2.0/src/items/container.h
*** nakedmudv1.5/src/items/container.h	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv2.0/src/items/container.h	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,26 ----
+ #ifndef CONTAINER_H
+ #define CONTAINER_H
+ //*****************************************************************************
+ //
+ // container.h
+ //
+ // handles all of the functioning of the container item type. Stores data about 
+ // the contents and capacity of a container, and all the functions for 
+ // interacting with container types.
+ //
+ //*****************************************************************************
+ 
+ double containerGetCapacity(OBJ_DATA *obj);
+ bool   containerIsClosable (OBJ_DATA *obj);
+ bool   containerIsClosed   (OBJ_DATA *obj);
+ bool   containerIsLocked   (OBJ_DATA *obj);
+ int    containerGetKey     (OBJ_DATA *obj);
+ int    containerGetPicKDiff(OBJ_DATA *obj);
+ void   containerSetCapacity(OBJ_DATA *obj, double capacity);
+ void   containerSetClosed  (OBJ_DATA *obj, bool closed);
+ void   containerSetClosable(OBJ_DATA *obj, bool closable);
+ void   containerSetLocked  (OBJ_DATA *obj, bool locked);
+ void   containerSetKey     (OBJ_DATA *obj, int  vnum);
+ void   containerSetPickDiff(OBJ_DATA *obj, int  diff);
+ 
+ #endif // CONTAINER_H
